import serial

######Signal Config########
NUL = "00".decode("hex")
SOH = "01".decode("hex")
STX = "02".decode("hex")
EOT = "04".decode("hex")
ACK = "06".decode("hex")
NAK = "15".decode("hex")
CAN = "18".decode("hex")
Cee = "43".decode("hex")
######Signal Config########

def hex2dec(s):
    return int(s, 16)

def getpackage128():
    tmp = ser.read(1)
    for i in range(127):
      tmp += ser.read(1)
    return tmp

def getpackage1024():
    tmp = ser.read(1)
    for i in range(1023):
      tmp += ser.read(1)
    return tmp
    
def sendready4file():
    ser.write(ACK)
    ser.write(Cee)

def alldone():
    ser.write(ACK)
    ser.write(Cee)
    ser.write(ACK)
    
def getinfo(package):
    name = ''
    size = 0
    i = 0
    i2 = 0
    while package[i] <> NUL:
        i += 1
    name = package[0:i]
    i2 = i+1
    i += 2
    while package[i] <> NUL:
        i += 1
    size = package[i2:i]
    return(name,int(size))

def getpacknum():
    ser.read(1) #1. Byte = NUL bei daten unter 265kbyte => verwerfen
    tmp = ser.read(1)
    tmp = tmp.encode("hex")
    tmp = hex2dec(tmp)
    return 255 - tmp

def getheader():
    tmp = ser.read(1)
    if tmp == SOH:
        return "SOH"
    elif tmp == STX:
        return "STX"
    elif tmp == EOT:
        return "EOT"
def getCRC():
    tmp = ser.read(1)
    tmp += ser.read(1)
    return tmp

def crc16str(s):
    crc = 0
    for index1 in range(len(s)):
        crc = crc ^ (ord(s[index1]) << 8)
        for index2 in range(1, 9):
            if crc & 0x8000 != 0:
                crc = ((crc << 1) ^ 0x1021)
            else:
                crc = crc << 1
    return crc & 0xFFFF

ser = serial.Serial(1)
ser.timeout = 0.1
header = ''
while True:
    ser.write(Cee)
    header = getheader()
    if header == "SOH":
        break
    
print "Pack Nr: " + str(getpacknum())
infop = getpackage128()
print "Content: " + infop
print "CRC recv: " + str(getCRC().encode("hex"))
print "CRC calc: " + hex(crc16str(infop))
info = getinfo(str(infop))
print "File: " + info[0] + "; Size: " + str(info[1]) + "byte\n"
sendready4file()
header = getheader()
while header <> "EOT":
    print "Header: " + header
    print "Pack Nr: " + str(getpacknum())
    if header == "SOH":
        content = getpackage128()
    else:
        content = getpackage1024()
    print "Content: " + content
    print "CRC recv: " + str(getCRC().encode("hex")) 
    print "CRC calc: " + hex(crc16str(content)) + "\n"
    ser.write(ACK)
    header = getheader()
alldone()
ser.close()
