{{ ---------------------------------------------------------------------------------------------------------

Hive-Computer-Projekt: YMODEM "Library"

xx-xx-2009      - 1. Version by Julian R.

Todo:
        - Upload via YMODEM
        - recieve files > 255kbyte
        - Batch file transfer? (maybe)

Big thanks to all ppl from the hive-project.de board.

 --------------------------------------------------------------------------------------------------------- }}
OBJ
  ios     : "ios"
  ser : "FullDuplexSerial256"     ' Full Duplex Serial Controller
  
CON
   '' Ymodem Protocol
  SOH           = 1               ' Packet Start 128byte
  STX           = 2               ' Packet Start 1024byte
  EOT           = 4               ' End of Transmission
  ACK           = 6               ' Positive Acknowledgement
  NAK           = 21              ' Negative Acknowledgement
  CAN           = 24              ' Cancel
'  PAD               = 26              ' Padding at the end of the file
'  RX_Buffer         = 20
  Cee           = 67              ' C to singalisize to be ready for/finished recieving data
  NUL           = 0               ' Filling Symbol for first package (0)

  ''crc
  P_CCITT      = $1021

   '' Serial Config
  serXmit       = 30              ' Serial Transmit
  serRecv       = 31              ' Serial Receive
  baud          = 9600            ' Baud Rate
  timeout       = 200             ' Timeout

VAR
  BYTE BUFs[128]               ' Small buffer for 128byte packets
  BYTE BUFb[1024]              ' Big buffer for 1kbyte packets
  
PUB download | mode,init,packnr,oldpacknr,filename,filesize,CRC,header
  mode := 0
  init := False
  ios.print(@msg0)
  ios.printnl
  ser.start(serRecv,serXmit,0,baud)                     ' init Serial Connection
  REPEAT while init <> true
    if ios.key == "c"
      ios.print(string("Cancled"))
      QUIT
    init := initdownload
  if init == true
    ios.print(string("Ini succeded!"))
    ios.printnl
    mode := 1
    'ios.printdec(packnr)
    repeat while mode <> 3
      if mode == 2
        header :=  getheader
        if header == EOT
          senddlfinish
          QUIT
         
      packnr := getpacknum
      
      if packnr == 0
         getpack128  
         filename := getfilename
         filesize := getfilesize(@BUFs,strsize(filename) +2)
         ios.print(string("Filename: "))
         ios.print(@filename)
         ios.printnl
         ios.print(string("CRC calculated: "))
         ios.printhex(calccrc(@BUFs),4)
         ios.printnl
         CRC := getcrc
         ios.print(string("CRC recieved: "))
         ios.printhex(CRC,4)
         ios.printnl 
         ios.sdopen("w",string("ydebg.txt"))
         bwrites(@BUFs)
         ios.sdclose
         senddlstart
         ios.sdopen("w",string("ydl.txt"))
         mode := 2
      elseif oldpacknr > packnr
        'print error
        'cancle Transfer
        ios.print(string("Wrong Head number"))     
      else
        'download content
        ios.print(String("Header :"))
        ios.printhex(header,2)
        ios.printnl
        Case header
          SOH:
            getpack128
            getcrc
            'CRC Check needed
            bwrites(@BUFs)
            sendack
            ios.print(string("Request next pack"))
            ios.printnl
          STX:
            getpack1k
            getcrc
            'CRC Check needed
            bwriteb(@BUFb)
            sendack
            ios.print(string("Request next pack"))
            ios.printnl
          Other:
            ios.print(string("Unknown Header! Cancled!"))
            ios.printnl
            cancledownload
            mode := 3
        oldpacknr := packnr
  ios.print(string("Finished!"))          
  ios.sdclose  
  ser.stop                                              ' stop Serial Connection  
PRI initdownload | header                               ' Repeat this function until True
  ser.tx(Cee)                                           ' Send C to singalisize readiness
  header := ser.rxtime(timeout)
  if header == SOH                                      ' Check if remote site sent first packet
    return TRUE
  else
    return FALSE
  
PRI getheader | recv, retvalue
  recv := ser.rx
  return recv

PRI getcrc | crc, crc1, crc2
  crc1 := ser.rx
  crc2 := ser.rx
  crc := crc1 <<8 + crc2
  return crc

PRI getpacknum | tmp, recv
  tmp := ser.rx                                         ' first Byte is NUL (files under 255kbyte)
  recv := ser.rx                                        ' Get Number
  return 255 - recv                                     ' Number counts down from 255

PRI getpack128 | i
  repeat i from 0 to 127
    BUFs[i] := ser.rx 

PRI getpack1k | i
  repeat i from 0 to 1023
    BUFb[i] := ser.rx

PRI getfilename | name,i,j,chr
  repeat i from 0 to 127
    chr := byte[BUFs[i]]
    if chr == NUL
      QUIT
  repeat j from 0 to i
    name += byte[BUFs[j]]
  return name

PRI getfilesize(packet,start) | size,i,j,chr
  repeat i from start to 127
    chr := byte[packet[i]]
    if chr == NUL
      QUIT
  repeat j from start to i
    size += byte[packet[j]]
  return size

PRI cancledownload
  ser.tx(CAN)
  ser.tx(CAN)
  ser.tx(CAN)
  ser.tx(CAN)

PRI sendack
  ser.tx(ACK)

PRI sendnak
  ser.tx(NAK)

PRI senddlstart
  ser.tx(ACK)
  ser.tx(Cee)
  
PRI senddlfinish
  ser.tx(ACK)
  ser.tx(Cee)
  ser.tx(ACK)
  
PRI calccrc(ptr) | i,j,count,crc,c
  crc := 0
  count := strsize(ptr)-1
  repeat i from 0 to count
    c := byte[ptr + i]  'byte[ptr][i]
    c := c << 8
    repeat j from 0 to 7
      if ( (crc ^ c) & $8000 )
        crc := (crc << 1) ^ P_CCITT
      else
        crc := crc << 1

      c := c << 1
      
  return crc
PRI bwrites(puffer) | n,i

repeat i from 0 to 127
  n := byte[puffer][i]
  ios.sdputc(n)
  
PRI bwriteb(puffer) | n,i

repeat i from 0 to 1023
  n := byte[puffer][i]
  ios.sdputc(n)
  
PRI checkfile | status
  status := ios.sdopen("r",@yfile)                   'check if file present
  ios.sdclose                                        'close file
  if status == 0                                     'file is present
    ios.print(@msg1)
    if ios.keywait <> "y"
      ios.print(string("no"))
      ios.printnl
      return false
    else
      ios.print(string("y"))
      ios.printnl
      return true
  else
    return true
DAT

yfile         byte      "ydbg.txt",0
msg0          byte      13,"yLoad Devel JR",13,0
msg1          byte      "File does already exist! overwrite? <y/n>: ", 0